<?php
/*---------------------------------------------------------------*/
/*
    Titre : Sondage php complet.                                                                                          
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=207
    Auteur           : kof_eve                                                                                            
    Date dition     : 23 Jan 2007                                                                                        
    Date mise  jour : 18 Sept 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - refactoring du code en PHP 7                                                                                        
    - fonctionnement du code vérifié                                                                                    
*/
/*---------------------------------------------------------------*/?>

//================= Table ====================
-- 
-- Structure de la table `vote`
-- 

CREATE TABLE `vote` (
  `id` smallint(10) unsigned NOT NULL auto_increment,
  `titre` tinytext NOT NULL,
  `reponse` smallint(1) NOT NULL default '0',
  `ip` varchar(15) NOT NULL default '',
  `unix` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
      

//================== Page vote.php  ===================

<html>
<head>
<title>Sondage</title>
</head>

<body>
<?php
    $db_server = 'localhost'; // Adresse du serveur MySQL
    $db_name = '';            // Nom de la base de données
    $db_user_login = 'root';  // Nom de l'utilisateur
    $db_user_pass = '';       // Mot de passe de l'utilisateur

    // Ouvre une connexion au serveur MySQL
    $conn = mysqli_connect($db_server,$db_user_login, $db_user_pass, $db_name);

// ip du client
    if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
    $ip = $_SERVER['HTTP_CLIENT_IP'];
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } else {
    $ip = $_SERVER['REMOTE_ADDR'];
    }

$unix = time(); // temps actuel.
$temps = time()-3600; // le temps y'as maintenant une heure.

// on demande a notre table de nous donné tous les ip qui ressemble a l'ip de
// notre visiteur actuel, et qui ne sont pas
// daté de plus d'une heure.
 
$q = $conn->query("SELECT ip FROM vote WHERE ip='$ip' AND unix > '$temps'");

if($q->num_rows > 0){
// Si oui, ca veut dire que notre visiteur a déjà voté, on lui affiche alors
// un
// message de remerciements, et les résultats.
  
  echo 
'<p style="font-size:20px;text-align:center;color:#660000"><strong>Merci' .
' d\'avoir voté !</strong></p>';
  $sql = "SELECT reponse FROM vote WHERE titre='lieu_de_championat'"; 
//on récupere le résultat des anciens votes.
  $result = $conn->query($sql);
  
  while($resultat = mysqli_fetch_array($result)) {
    $cadre[] = $resultat['reponse'];  
//on récupere le résultat de notre requête, et on le stocke dans un tableau.
  }
  
  
//on stocke le total du vote dans une variable "$totalvote" via la méthode
// "count" qui parcourt tout notre tableau. 
  $totalvote= count($cadre); 
  
  
// on stocke le nombre de chaque choix dans un tableau avec la méthode
// "array_count_values" .. qui retourne par exemple.
  
//$array = array(1, "tyty", 1, "slt", "tyty");   array_count_values($array);   
// retourne array(1=>2, "tyty"=>2, "slt"=>1)
  $totalreponse = array_count_values($cadre);

  
//Maintenant on calcule le pourcentage de nos votes selon la régle universel
// pour ca ^^  "p = chifre x 100 / total".
  
// pour ca on utilise "bcdiv" qui divise et renvoie le résultat sous forme de
// chaîne de caractères.(en plus qu'on peut la fixé comme içi à 2 chiffres
// après
// la virgule). sinon on aura parfois des pourcentage genre 65.2323232323% et
// c'est pas beau >_<
  
    $reponse1 = bcdiv($totalreponse[1]*100, $totalvote, 2); 
    $reponse2 = bcdiv($totalreponse[2]*100, $totalvote, 2);
    $reponse3 = bcdiv($totalreponse[3]*100, $totalvote, 2);
    $reponse4 = bcdiv($totalreponse[4]*100, $totalvote, 2);

  
// pour l'affichage on utilise une petite fonction ^^ .. Prenez le temps de la
// comprendre, c'est facile.
    
  function VerifText($text,$valeur,$reponse,$totaldesreponse){  
      if ($text < '1'){ 
// on teste si le total des votes est moins qu'un, alors, on n'affiche pas
// d'image, et on met "0" comme valeur du vote
        $text1 = '<strong> - '.$valeur.' : </strong>'.$reponse.
'%      <strong>0</strong> vote.<br />';
      }
      if ($text == '1'){ 
// on teste si le total des votes est égal a 1, alors, on affiche l'image de la
// barre avec comme valeur de Width, "la variable du pourcentage", et on met la
// "valeur du vote".
        $text1 = '<strong> - '.$valeur.' : </strong>'.$reponse.
'%   <img src="barre.gif" alt="chargement impossible" height="5" width="'.
$reponse.'" />   <strong>'.$totaldesreponse.'</strong> vote.<br />';
      }
      if ($text > '1'){  
// on teste si le total des votes est plus grand que 1, alors, on affiche
// l'image de la barre avec comme valeur de Width, "la variable du pourcentage",
// et on met la "valeur du vote" avec une "s" a la fin cette fois. c tt
        $text1 = '<strong> - '.$valeur.' : </strong>'.$reponse.
'%   <img src="barre.gif" alt="chargement impossible" height="5" width="'.
$reponse.'" />   <strong>'.$totaldesreponse.'</strong> votes.<br />';
      } 
    return $text1;
  }
  
  // la on affiche notre fonction avec ces nouveaux paramètres.
  
//VerifText($_variable_du_total_du_vote , 'Valeur a affiché dans notre page' ,
// $_variable_de_notre_pourcentage , $_variable_du_total_du_vote);
  //ce qui donne quelque chose comme ça.

  echo VerifText($totalreponse[1],'valeur 1',$reponse1,$totalreponse[1]).
VerifText($totalreponse[2],'valeur 2',$reponse2,$totalreponse[2]). VerifText(
$totalreponse[3],'valeur 3',$reponse3,$totalreponse[3]).VerifText($totalreponse[
4],'valeur 4',$reponse4,$totalreponse[4]);
  echo '<strong> Total votes : </strong>'.$totalvote.'<br /><br /><br />';
  
// on répète notre fonction n fois nos choix avec une "." Pour la
// concaténation 
// , et une autre echo pour le total des votes.


}else{ 
// Si non, ça veut dire que notre visiteur n'as pas encore voté, on lui
// affiche
// le formulaire avec les choix.
  echo 'Quelle Valeur souhaité vous ? <br /><br />';
  echo 
'<form method="POST" action="vote.php?vote=ok"><div><input class="zonetext"' .
' type="radio" value="1" name="choix" /> - Valeur 1<br /><input class="zonetex' 
.
't" type="radio" value="2" name="choix" /> - Valeur 2<br /><input class="zonet' 
.
'ext" type="radio" value="3" name="choix" /> - Valeur 3<br /><input class="zon' 
.
'etext" type="radio" value="4" name="choix" /> - Valeur 4<br /><input class="z' 
.
'onetext" type="submit" value=" Ok ! " /></div></form>';      
      
}  


// Enregistrement du vote dans la table si le vote est diffèrent de "0" , ce
// qui
// veux dire que le gars a validé le formulaire sans prendre un choix.
// Et si la variable "vote" récupéré par la méthode $_GET et égal a "ok",
// ce qui
// veut dire que c'est le formulaire qui as envoyé cette page, pas un simple
// lien.


if ($_GET['vote']=='ok' AND $_POST['choix']!=0){
  $enregistrer = 
"INSERT vote SET id='', titre='lieu_de_championat', reponse='".$_POST['choix'].
"', ip='$ip', unix='$unix'";
  $conn->query($enregistrer);
  header("Location: vote.php"); // la on ré-actualise notre page..
}

?>
     </body>
     </html>
